# CHANGELOG



## v1.0.0 (2024-05-20)

### Breaking

* feat: Use click and autogenerated arguments from YAML parameter file

BREAKING CHANGE: arguments may not be propagated exactly the same way as previously ([`47cdaff`](https://github.com/2428/Aquila-Consortium/map2map/commit/47cdaffd81099be244fba2212f8966b6ca375721))

### Build

* build: Add map2map version tag ([`de785cf`](https://github.com/2428/Aquila-Consortium/map2map/commit/de785cf60062d6e46d1bcff957f67efcf7981906))

### Chore

* chore: Add new_release script to create a new release ([`ac7fed3`](https://github.com/2428/Aquila-Consortium/map2map/commit/ac7fed30d5f74b4a526919ff0794fe7d05a81c89))

* chore: Update README ([`ea73381`](https://github.com/2428/Aquila-Consortium/map2map/commit/ea73381806fd6da9b1acf6d3741f95038373f1ca))

* chore: Blackify the source code for pretty formatting ([`7361c3e`](https://github.com/2428/Aquila-Consortium/map2map/commit/7361c3eb9d0eb4724c982ef0ecb20661d028c748))

### Feature

* feat: Use semantic-release and automatic git hooks check ([`661b17e`](https://github.com/2428/Aquila-Consortium/map2map/commit/661b17eea1cd460e4d634cecab213d47bacf028a))

### Fix

* fix: Add missing __version__ in map2map ([`0bc782d`](https://github.com/2428/Aquila-Consortium/map2map/commit/0bc782db2a5e68a49b61a7e603bab7236d1a2957))

### Unknown

* Bypass check for version commit ([`034b7e8`](https://github.com/2428/Aquila-Consortium/map2map/commit/034b7e8273e88d44573d604501cffd8f275af1bf))

* Merge pull request &#39;feat: Use click and autogenerated arguments from YAML parameter file&#39; (#1) from features/configuration into main

Reviewed-on: https://git.aquila-consortium.org/Aquila-Consortium/map2map/pulls/1 ([`ec9732d`](https://github.com/2428/Aquila-Consortium/map2map/commit/ec9732df2180fa431c1f527af4c70fc6e0d4de37))

* Fix package name ([`659081a`](https://github.com/2428/Aquila-Consortium/map2map/commit/659081ac869191f1ee4fa39bd4d000fd7d502318))

* Update dependencies ([`ffc1fbe`](https://github.com/2428/Aquila-Consortium/map2map/commit/ffc1fbe806487d6ef7cc00b401c7169c652bc93f))

* Update  links ([`534d177`](https://github.com/2428/Aquila-Consortium/map2map/commit/534d177a520c89441cb0ade5c32f6f0182835eb2))

* Basic cleanup ([`90a14d5`](https://github.com/2428/Aquila-Consortium/map2map/commit/90a14d56b9cca91344c0c8769652a3db8950761d))

* Remove unnecessary setup.py now ([`68e466c`](https://github.com/2428/Aquila-Consortium/map2map/commit/68e466c983790ab74ccc96c616e78ede4471b44b))

* Removed spurious tool ([`7b32bc8`](https://github.com/2428/Aquila-Consortium/map2map/commit/7b32bc8b29f371161e862dc02cca182c69248fcb))

* Add pyproject, better cross-referencing ([`050b6be`](https://github.com/2428/Aquila-Consortium/map2map/commit/050b6be80ccde7fbff8b004d81530972b758a991))

* Import patches from Deaglan fork

commit 15e35b2c91d7b4c0a0158747c8059e756d110fad
Author: Deaglan Bartlett &lt;deaglan.bartlett@physics.ox.ac.uk&gt;
Date:   Mon Sep 11 22:51:30 2023 +0200

    Fix power issue in plotting

commit 048e53bb447faa569dfc86a0b29dd1216974fc21
Author: Deaglan Bartlett &lt;deaglan.bartlett@physics.ox.ac.uk&gt;
Date:   Mon Sep 11 20:23:16 2023 +0200

    Fix tgt norm correction bug

commit 088fda3c4c799f3b6d1233ba7419201c78282483
Author: Deaglan Bartlett &lt;deaglan.bartlett@physics.ox.ac.uk&gt;
Date:   Tue Sep 5 15:38:21 2023 +0200

    Minor changes for coca ([`e24343e`](https://github.com/2428/Aquila-Consortium/map2map/commit/e24343e63d3b0599f67b458e69e6ce9b8824a73c))

* Remove Lagrangian part ([`352482d`](https://github.com/2428/Aquila-Consortium/map2map/commit/352482d4752fb9d69eb429dd7226b235a650f901))

* Add cuda backend to inference ([`0d4ae34`](https://github.com/2428/Aquila-Consortium/map2map/commit/0d4ae3424e30c6ec1707688c2c37a6b78a320d80))

* Cleanup, Enable plt_power by default ([`e20a3e3`](https://github.com/2428/Aquila-Consortium/map2map/commit/e20a3e3f622b226a1747b1d634beb916335eec80))

* Cleanup name and comments ([`c7836ad`](https://github.com/2428/Aquila-Consortium/map2map/commit/c7836ad7be1f34b296c307f8a22dfbd56933cde3))

* Fix bug when dis is Tensor ([`1181ff0`](https://github.com/2428/Aquila-Consortium/map2map/commit/1181ff0f63fb1b6c6e7429ccb9806a21b1103294))

* Fix bug with shared displacement field ([`6a3990f`](https://github.com/2428/Aquila-Consortium/map2map/commit/6a3990f90c4e55dc2430b402b0bcb9e85377a3c4))

* Fix slice figures with many zeros

the bug was triggered when many pixels are zero valued:
taking log of 0 in quantize() ([`b7a97bb`](https://github.com/2428/Aquila-Consortium/map2map/commit/b7a97bbcdc59a1381731217f90d3c7643cdfc361))

* Set matplotlib usetex to False ([`eccbd68`](https://github.com/2428/Aquila-Consortium/map2map/commit/eccbd68f03dd8caf2afdc1701da67c5f656ca0ab))

* Add Eulerian shape logging ([`3d271e9`](https://github.com/2428/Aquila-Consortium/map2map/commit/3d271e9c44e5831bbd96217d87140673b5ca997b))

* Add scale factor and pad to lag2eul Eulerian field ([`6b55302`](https://github.com/2428/Aquila-Consortium/map2map/commit/6b5530256b5d614ed6d813749cd256b8222a858b))

* Add misc kwargs passing to custom models and norms ([`04d0bea`](https://github.com/2428/Aquila-Consortium/map2map/commit/04d0bea17e0c11fcfb6d60976640671967488a39))

* Move the executable script to the right place

so that calling it runs the local map2map ([`8a3cd18`](https://github.com/2428/Aquila-Consortium/map2map/commit/8a3cd1843d01c1307d06df83c47ebcad7a67675c))

* Add matplotlib and tensorboard requirements ([`413221a`](https://github.com/2428/Aquila-Consortium/map2map/commit/413221af7ba103897db68a02c80e988d58b3aea8))

* Remove many item() to avoid unnecessary cpu-gpu sync ([`2717269`](https://github.com/2428/Aquila-Consortium/map2map/commit/2717269a8d9713d41b530cc02ea5242edfd6ebfe))

* Fix again rfft call broken by pytorch breaking BC ([`5e4633b`](https://github.com/2428/Aquila-Consortium/map2map/commit/5e4633b125863955718bff0cbed990210945b9bb))

* Fix crop and pad are for the shapes after perm()

not before it!
This only matters for non-cubic crop and pad ([`795cefe`](https://github.com/2428/Aquila-Consortium/map2map/commit/795cefe38e6fcfcea64942c2b09f2a101f123d04))

* Remove size argument from crop ([`08c805e`](https://github.com/2428/Aquila-Consortium/map2map/commit/08c805e47aa2ead14ff53c6ed0e9b35e0e34a4a6))

* Fix rfft call broken by pytorch breaking BC ([`002e249`](https://github.com/2428/Aquila-Consortium/map2map/commit/002e24992500b4b16b79ae0225b336bf949c611b))

* Remove tab ([`4898724`](https://github.com/2428/Aquila-Consortium/map2map/commit/4898724ac185b001ccdb1e4ae00c17c8546dc166))

* Improve FieldDataset.assemble ([`abb16fe`](https://github.com/2428/Aquila-Consortium/map2map/commit/abb16fe26a51ec16466c993d1f02821622b84361))

* Change default number of dataloader workers

as suggested by pytorch ([`0410435`](https://github.com/2428/Aquila-Consortium/map2map/commit/0410435a8a6820bc4773ec01e2e2328374d6044e))

* Add styles to test.py ([`3eaca96`](https://github.com/2428/Aquila-Consortium/map2map/commit/3eaca964ed25feeb606199a7cc2e688154253ff2))

* Fixes and cleaning following 183a223 55b1a72 8544ff0 ([`01c2e45`](https://github.com/2428/Aquila-Consortium/map2map/commit/01c2e454309fe43041d1b5ef61bc837974b8dd80))

* Rename param to style ([`a61990e`](https://github.com/2428/Aquila-Consortium/map2map/commit/a61990ee459978144e5216f0ffa31223735dba0c))

* Add styled VNet and Fix bugs

Co-authored-by: Drew Jamieson &lt;drew.s.jamieson@gmail.com&gt; ([`17d8e95`](https://github.com/2428/Aquila-Consortium/map2map/commit/17d8e95870b4b9ffe6d7e1926a3a64b5d693a30b))

* Duplicate vnet.py for future modification

To incorporate styled convolution from style.py ([`f5bd657`](https://github.com/2428/Aquila-Consortium/map2map/commit/f5bd6576258d4e678ddb3e90280eff3e3514048e))

* Add style components from stylegan2

* styled convolution with mod and demod
* pixelnorm
* linear and conv layers with equalized learning rate ([`a697845`](https://github.com/2428/Aquila-Consortium/map2map/commit/a69784593328c56057f4090d60d11df2cf38c2b3))

* Add parameter reading ([`4706a90`](https://github.com/2428/Aquila-Consortium/map2map/commit/4706a902f6e9c0df49a1dbb3fdad3eccced9a8dd))

* Add assemble to FieldDataset to undo cropping ([`9d3253a`](https://github.com/2428/Aquila-Consortium/map2map/commit/9d3253ac48d86bd4bfa1db9e9c4ae3c29ae7d0e9))

* Fix and improve SRSGAN ([`89e8651`](https://github.com/2428/Aquila-Consortium/map2map/commit/89e8651c2655947d7d0b1beb9ac5f93652b36748))

* Add module and conda env recording ([`4be71a3`](https://github.com/2428/Aquila-Consortium/map2map/commit/4be71a32d1fb8b17947111cc7e8f2bb2ff3b5919))

* Fixes and cleaning up ([`8544ff0`](https://github.com/2428/Aquila-Consortium/map2map/commit/8544ff07e8eb11ec6a38b2006fff145e2a3dbd6c))

* Add kernel_size and stride to ResBlock ([`55b1a72`](https://github.com/2428/Aquila-Consortium/map2map/commit/55b1a72ef4acc3ce9a4d970d1323f1cdc3844165))

* Add unequal/asymmetric cropping, padding, and aug_shift ([`fd1cdb0`](https://github.com/2428/Aquila-Consortium/map2map/commit/fd1cdb0ce73808cb117de6188497426934c9f57f))

* Fix error type ([`183a223`](https://github.com/2428/Aquila-Consortium/map2map/commit/183a223ee64d0c6668f4c29bcc7ff188096ef0e9))

* Add cmap and norm for all non positive images in plt_slices ([`c102fc5`](https://github.com/2428/Aquila-Consortium/map2map/commit/c102fc588ee2c75c13aba4d3ceb6cfcebc14cf67))

* Change crop, flip, perm to in-place ([`e40ea52`](https://github.com/2428/Aquila-Consortium/map2map/commit/e40ea52190d49738fec3c5611fa9f34b1ed97b1d))

* Fix indentation bug pointed out by Patrick Lachance ([`156011b`](https://github.com/2428/Aquila-Consortium/map2map/commit/156011be5f3c759b5bbc85dbbb5e4f63a14ba832))

* Broaden linear region of SymLogNorm in plt_slices ([`7971137`](https://github.com/2428/Aquila-Consortium/map2map/commit/7971137ad49219a510dab7a523fc1a03dc71dd79))

* Add identity normalization ([`3f35a5c`](https://github.com/2428/Aquila-Consortium/map2map/commit/3f35a5cca6a3ebbd905630fc0711546fe6e61bd3))

* Add pytorch version reporting ([`b7a9adf`](https://github.com/2428/Aquila-Consortium/map2map/commit/b7a9adf0c7dfe27e47949fada0cb59d0c58e7563))

* Replace assert with raise ([`a579c96`](https://github.com/2428/Aquila-Consortium/map2map/commit/a579c9655bb85c677bd4cc43a1cc508e1e610e3d))

* Add optional optimizer/scheduler loading ([`55f61b9`](https://github.com/2428/Aquila-Consortium/map2map/commit/55f61b9a708cf33e10071de353dac2638312d624))

* Fix import_attr bug pointed out by David Schaurecker ([`b215c0f`](https://github.com/2428/Aquila-Consortium/map2map/commit/b215c0fa7b8978a1056d38fb7e200f1d1310a465))

* Fix to rename --batches to --batch-size, former kept for BC ([`4799f81`](https://github.com/2428/Aquila-Consortium/map2map/commit/4799f8177ce661fe5451eab2e809f0575f4b94d0))

* Revert removal of saving/loading optimizer &amp; scheduler states

Why did I do that? ([`7be3153`](https://github.com/2428/Aquila-Consortium/map2map/commit/7be3153206392310d67e4796396a832a674108d2))

* Add autograd detect anomaly flag, and test cudnn.deterministic

cudnn.deterministic is only 10% slower ([`85efb9e`](https://github.com/2428/Aquila-Consortium/map2map/commit/85efb9e3a3d5049f61c7026df11f1ebda5157685))

* Move figures from .data to .utils ([`d8c6be7`](https://github.com/2428/Aquila-Consortium/map2map/commit/d8c6be797d203107293001a42ee817156cc52e52))

* Add tgt_pad, rename pad to in_pad

tgt_pad can be useful for scale_factor &gt; 1 ([`154376d`](https://github.com/2428/Aquila-Consortium/map2map/commit/154376d95afd213ca46301189d4d8f07e9efa9b6))

* Replace narrow_like by narrow_by in UNet/VNet

This makes it traceable / scriptable.
Note that the narrow_like in ResBlock used by VNet is not changed yet ([`39ad594`](https://github.com/2428/Aquila-Consortium/map2map/commit/39ad59436e9c20c5495354a94009c66e5574f678))

* Add plt_slices(size=None) ([`c4ab7e0`](https://github.com/2428/Aquila-Consortium/map2map/commit/c4ab7e065b66b9cd08aef2f8e2ba13b7072a18b4))

* Fix error pickling normalization function in multiprocessing dataloading

By avoiding importing functions as class attributes but importing before
calling, and using cache in the importing function

Thanks to help by Yu Feng ([`6c62cb0`](https://github.com/2428/Aquila-Consortium/map2map/commit/6c62cb09dbf63dcc4835712672d9bb741a6d7d20))

* Fix import bug that prevents pickling of norm functions

https://docs.python.org/3/library/importlib.html#importing-a-source-file-directly
https://stackoverflow.com/questions/43819653/pickling-objects-imported-with-importlib-util/53696167#53696167 ([`0e0ad8f`](https://github.com/2428/Aquila-Consortium/map2map/commit/0e0ad8f071ce8978196a50d5615cf31ca0b57c5a))

* Add multiple pkgs to import_attr ([`f3216f4`](https://github.com/2428/Aquila-Consortium/map2map/commit/f3216f4cbdcd508ecfe7118eeb98d0c46865121f))

* Fix two power spectrum bugs about freq shift and flatten ([`79b2856`](https://github.com/2428/Aquila-Consortium/map2map/commit/79b28561d55e664c4c83ada60bfe302735417478))

* Fix cropping bug when scale_factor&gt;1 ([`6c67eaa`](https://github.com/2428/Aquila-Consortium/map2map/commit/6c67eaa788d848477fd03cd821d874ccd582242d))

* Change Lag2Eul to lag2eul as a function ([`670364e`](https://github.com/2428/Aquila-Consortium/map2map/commit/670364e54cbf06b8a293af54f36426dd83a9e963))

* Add power spectrum tracking ([`3eb1b0b`](https://github.com/2428/Aquila-Consortium/map2map/commit/3eb1b0bccc096276ed075445548a926a18040533))

* Add power spectrum module ([`afaf467`](https://github.com/2428/Aquila-Consortium/map2map/commit/afaf4675fe741e155e56b913dbe2f0f36ed8a3b1))

* Add shape report after narrow_cast in training ([`5d22594`](https://github.com/2428/Aquila-Consortium/map2map/commit/5d22594edee4bf613605dd333bd983859c5c1c49))

* Change VNet based on experiment on displacement ([`01cc1b6`](https://github.com/2428/Aquila-Consortium/map2map/commit/01cc1b6964636516e71ebb15e6eaf627c2beb5dc))

* Fix module before __init__ bug ([`ebd962e`](https://github.com/2428/Aquila-Consortium/map2map/commit/ebd962e333c72fc3c20f0ecc55800b2fb145b721))

* Add center slicing in plt_slices

Also fix bug of hard coded `size` ([`61ca400`](https://github.com/2428/Aquila-Consortium/map2map/commit/61ca4009427d931cfa2f6c8e6b8073b50ab4ccb6))

* Add loglxe loss as log of product of Lagrangian and Eulerian losses ([`9c8b331`](https://github.com/2428/Aquila-Consortium/map2map/commit/9c8b331bf5c84b198f2a81e4952592249fd3024d))

* Add optional trailing activation to residual block ([`13edf3b`](https://github.com/2428/Aquila-Consortium/map2map/commit/13edf3b96dc7b11adea8754d0c0e395bb5e9933e))

* Fix args helps ([`a1e5399`](https://github.com/2428/Aquila-Consortium/map2map/commit/a1e5399311f41649d0825eb236d61e9404f37beb))

* Change color normalization in plt_slices ([`6b65b78`](https://github.com/2428/Aquila-Consortium/map2map/commit/6b65b7888d6339649f1905d253b1c49c3e100dc6))

* Remove pyramid model ([`d6b7a52`](https://github.com/2428/Aquila-Consortium/map2map/commit/d6b7a528dfa551d2d7479271c3122d792b4f770b))

* Add documentation ([`728e059`](https://github.com/2428/Aquila-Consortium/map2map/commit/728e0597f066fbeaccea2f57bb0eb384d6960261))

* Add srsgan model and scale_factor to model arguments ([`2655879`](https://github.com/2428/Aquila-Consortium/map2map/commit/265587922d45b4fd3ba851382f4d6af914f81ae2))

* Fix --optimizer-args None default bug ([`6dfde5e`](https://github.com/2428/Aquila-Consortium/map2map/commit/6dfde5ee7f960be26054eec7a2a14790e45c21cc))

* Replace specific slurm scripts with general ones ([`5ac9016`](https://github.com/2428/Aquila-Consortium/map2map/commit/5ac9016987d7e78012f463c626e391b68482b716))

* Add a line about socket hopefully will avoid port conflicts ([`b54fc4b`](https://github.com/2428/Aquila-Consortium/map2map/commit/b54fc4ba3a421bb2151cda679a32120df24016c8))

* Add plt.close to avoid matplotlib warning ([`0d41bda`](https://github.com/2428/Aquila-Consortium/map2map/commit/0d41bdae2635581b6ee0f7d4d9788fba44b5fbbd))

* Always use training loss for lr scheduler ([`a886e53`](https://github.com/2428/Aquila-Consortium/map2map/commit/a886e53c54d3eb319eb4dff57860f6edf836c8ae))

* Add optimizer and scheduler kwargs via json.loads ([`2336d83`](https://github.com/2428/Aquila-Consortium/map2map/commit/2336d83f2ddb6a598cdf566c7a5c14ecf7e1135b))

* Fix training hang due to constrained layout of matplotlib ([`8ce13e6`](https://github.com/2428/Aquila-Consortium/map2map/commit/8ce13e67f6ace14e54347dcc3fc275ea170d28cc))

* Merge remote-tracking branch &#39;refs/remotes/origin/lag2eul&#39; into lag2eul ([`bf9b0ba`](https://github.com/2428/Aquila-Consortium/map2map/commit/bf9b0ba4260e48a25a19b018cc2dcbd9a4363a23))

* Replace cuda.device with env var to assign GPU to processes ([`ca39b20`](https://github.com/2428/Aquila-Consortium/map2map/commit/ca39b2028fdd71344e623347d74b2d2d0a064fb2))

* Merge remote-tracking branch &#39;refs/remotes/origin/lag2eul&#39; into lag2eul ([`f98b0fb`](https://github.com/2428/Aquila-Consortium/map2map/commit/f98b0fbbd095cb6b611a085bbb99186a2824c45f))

* Add DistFieldSampler to benefit from page cache ([`98cdd47`](https://github.com/2428/Aquila-Consortium/map2map/commit/98cdd4795cde4982eaa5d95cf3eaa6c7e85d41f8))

* Merge branch &#39;lag2eul&#39; of github.com:eelregit/map2map into lag2eul ([`632c73d`](https://github.com/2428/Aquila-Consortium/map2map/commit/632c73db168ab0f8c99dd00fba394168d3e45766))

* Add DistFieldSampler to benefit from page cache ([`9f54e02`](https://github.com/2428/Aquila-Consortium/map2map/commit/9f54e02c3a9f3703e6a880be60f645b37dc3d23a))

* Add lag x eul loss tracking to tensorboard ([`ec46f41`](https://github.com/2428/Aquila-Consortium/map2map/commit/ec46f41ba51e2e21aefb935bfe07cf41e06bc682))

* Revert &#34;Deprecate GroupedRandomSampler for use of memmap in place of cache&#34;

This reverts commit bbf77c9f91ad04fc865e5ffd56270fddbdc56f43. ([`509856c`](https://github.com/2428/Aquila-Consortium/map2map/commit/509856cb4f82eba72c415c96008c7588b6c8f844))

* Revert &#34;Deprecate GroupedRandomSampler for use of memmap in place of cache&#34;

This reverts commit bbf77c9f91ad04fc865e5ffd56270fddbdc56f43. ([`56f8fa9`](https://github.com/2428/Aquila-Consortium/map2map/commit/56f8fa932b58ac84d3fe1ca2db3b23144bea807a))

* Merge remote-tracking branch &#39;refs/remotes/origin/lag2eul&#39; into lag2eul ([`5bc0992`](https://github.com/2428/Aquila-Consortium/map2map/commit/5bc099251f86c886eb09aa2e8c8edc24d595e981))

* Add lagrangian and eulerian alternate training ([`2d52348`](https://github.com/2428/Aquila-Consortium/map2map/commit/2d5234812bbcd868abe1d15c0f77752bceffcf36))

* Remove adversary ([`337d65d`](https://github.com/2428/Aquila-Consortium/map2map/commit/337d65de686dd16af355c5d26eb83693ecc14ddd))

* Add Lag2Eul to training ([`607bcf3`](https://github.com/2428/Aquila-Consortium/map2map/commit/607bcf3f4c2db4681e7f0eb1b79e51ffcd4c183e))

* Add Lagrangian-to-Eulerian transformation ([`40220e9`](https://github.com/2428/Aquila-Consortium/map2map/commit/40220e924873a04b4922292001a07bef68d0284c))

* Change default number of loader workers ([`ff4c2e1`](https://github.com/2428/Aquila-Consortium/map2map/commit/ff4c2e12fdbf0a9dc921bef625213cc2994d48f0))

* Remove shape dependence from narrow_by

Good for torchscript ([`7d3a598`](https://github.com/2428/Aquila-Consortium/map2map/commit/7d3a598080f0572e39318ba4d8b2b790072e95e4))

* Add lagrangian and eulerian alternate training ([`4160ed2`](https://github.com/2428/Aquila-Consortium/map2map/commit/4160ed25f710a071b50a0b3db8f8a628a288c6dc))

* Remove adversary ([`e8744d6`](https://github.com/2428/Aquila-Consortium/map2map/commit/e8744d6c7b2d4f1795a005ba41ce551fc4bb5f7a))

* Merge branch &#39;master&#39; into lag2eul ([`6fa85f8`](https://github.com/2428/Aquila-Consortium/map2map/commit/6fa85f8285ee36dd04b4f19b15b8d29aa656b09e))

* Deprecate GroupedRandomSampler for use of memmap in place of cache ([`bbf77c9`](https://github.com/2428/Aquila-Consortium/map2map/commit/bbf77c9f91ad04fc865e5ffd56270fddbdc56f43))

* Merge branch &#39;master&#39; into lag2eul ([`3437b20`](https://github.com/2428/Aquila-Consortium/map2map/commit/3437b20ed89aaef30a7f9354db4e574bf86be97d))

* Change default number of loader workers ([`5fd8cbf`](https://github.com/2428/Aquila-Consortium/map2map/commit/5fd8cbfcda256866802b6ff49034ea61146875af))

* Add memmap to numpy data loading ([`818ed69`](https://github.com/2428/Aquila-Consortium/map2map/commit/818ed6923db4bbd99b271aa42ce0cebc5c156e98))

* Merge branch &#39;master&#39; into memmap ([`eba76bf`](https://github.com/2428/Aquila-Consortium/map2map/commit/eba76bf90d5126e344a98c6d677fa0b81ec3128d))

* Replace np.take by advanced indexing for cropping ([`9abcee4`](https://github.com/2428/Aquila-Consortium/map2map/commit/9abcee48700c7be7640e9cf7fab773612221d672))

* Replace np.take by advanced indexing for cropping ([`c2edeb3`](https://github.com/2428/Aquila-Consortium/map2map/commit/c2edeb344ea47464fe832b17dd9eab21144345e5))

* Fix bug due to strange numpy type conversion ([`c61b6d6`](https://github.com/2428/Aquila-Consortium/map2map/commit/c61b6d6fabfb244fe92ab247c48afb397e9de781))

* Remove min-reduction; Split grad plots; Disable cgan w/o adv ([`d0ab596`](https://github.com/2428/Aquila-Consortium/map2map/commit/d0ab596e11750a2ec650ea2d68845a8443de6d71))

* Change instance noise

Simpler linear annealing as in the blog post;
different noise to output and target ([`29ab550`](https://github.com/2428/Aquila-Consortium/map2map/commit/29ab5500322c8eace281ef94fb246283dd75d024))

* Add linear resamplers ([`873258d`](https://github.com/2428/Aquila-Consortium/map2map/commit/873258d8a7fdb92ed45c8948d94478ceee520431))

* Add narrow_cast and narrow_by ([`c956dca`](https://github.com/2428/Aquila-Consortium/map2map/commit/c956dca79584921075fb15008b7298351758f8b1))

* Add pixel-shifting data augmentation ([`28ec245`](https://github.com/2428/Aquila-Consortium/map2map/commit/28ec245a7a3c34bf1d357663d0b2940d09c4c902))

* Add cropping anchors controlled by start, stop, step ([`8a95d69`](https://github.com/2428/Aquila-Consortium/map2map/commit/8a95d698185a1ea50869ce17e0c6f8a695e2308d))

* Add slice plotting for field &gt;2d ([`819e77c`](https://github.com/2428/Aquila-Consortium/map2map/commit/819e77cd8674ac49f02aea5c74e4d28d3c26b34e))

* Add Lagrangian-to-Eulerian transformation ([`5c4d244`](https://github.com/2428/Aquila-Consortium/map2map/commit/5c4d244a54886bd3c62a47958973e8a8942bfe6d))

* Add Lag2Eul to training ([`bab3f08`](https://github.com/2428/Aquila-Consortium/map2map/commit/bab3f08aa572eca70fbf230cbf5c77c767b6a9b1))

* Add Lagrangian-to-Eulerian transformation ([`9d2cd53`](https://github.com/2428/Aquila-Consortium/map2map/commit/9d2cd5383bb4b76c51b06bd40ff9536faf2b82cc))

* Change .pth to .pt following torch convention ([`c3d7456`](https://github.com/2428/Aquila-Consortium/map2map/commit/c3d7456d0c5b462b96f88d439ae14222fe3720e6))

* Fix README order ([`c3877ae`](https://github.com/2428/Aquila-Consortium/map2map/commit/c3877ae982f00f500904597088681fb1b5224b19))

* Merge branch &#39;master&#39; of github.com:eelregit/map2map ([`b1b3dbe`](https://github.com/2428/Aquila-Consortium/map2map/commit/b1b3dbe41cc681949fd7713e2ce0972e9a581b0e))

* Add callback loading mechanism ([`90a0d6e`](https://github.com/2428/Aquila-Consortium/map2map/commit/90a0d6e0f89c49d0e6b8aa6b3aa932ad283ced13))

* add sys library ([`63c2b1a`](https://github.com/2428/Aquila-Consortium/map2map/commit/63c2b1a39d0699fd10aad9fc359b14cabeb90e9e))

* Add grouped cache for data bigger than CPU RAM ([`5bb2a19`](https://github.com/2428/Aquila-Consortium/map2map/commit/5bb2a19933716b60de3cda0a5a4ab30cd13c0aa1))

* Add LRU cache to replace existing cache ([`2e687da`](https://github.com/2428/Aquila-Consortium/map2map/commit/2e687da9056b99e61bfa999e7fc06ce4aa550629))

* Refactor runtime default argument setting ([`4cc2fd5`](https://github.com/2428/Aquila-Consortium/map2map/commit/4cc2fd51ebe300681870e0f52f8fa272766f8453))

* Fix no data bug with --div-data ([`9b456d6`](https://github.com/2428/Aquila-Consortium/map2map/commit/9b456d6b1aeb7d165c49ea6d67f28cd7e80f0689))

* Improve figure appearance ([`8bb6e85`](https://github.com/2428/Aquila-Consortium/map2map/commit/8bb6e85c6d034960c7bfa0a3e334e78065e75cfc))

* Remove smooth transition halflife argument ([`2c5c4fa`](https://github.com/2428/Aquila-Consortium/map2map/commit/2c5c4fae2cf7414b97da9fd7a579770ea23a722d))

* Add additive and multiplicative augmentation ([`897c356`](https://github.com/2428/Aquila-Consortium/map2map/commit/897c3563db5f861dab4109894c3f114dec7d650a))

* Remove smooth transition to adversarial loss ([`67e5ed9`](https://github.com/2428/Aquila-Consortium/map2map/commit/67e5ed9eb682a85e0f5c1c0a916703746019e4c9))

* Remove noise channels ([`f442dd5`](https://github.com/2428/Aquila-Consortium/map2map/commit/f442dd59ba51e145ee2e0eb65c2f7ec98c70464a))

* Shrink space between images ([`3e13202`](https://github.com/2428/Aquila-Consortium/map2map/commit/3e13202fb5e8b2af2e69135cb0f7b6c6dabafcf9))

* Shrink colorbar length ([`9b06b0f`](https://github.com/2428/Aquila-Consortium/map2map/commit/9b06b0f1a75b1bde07cc7df0f7ea956bce83639e))

* Shrink image sizes ([`69e9992`](https://github.com/2428/Aquila-Consortium/map2map/commit/69e99925451f0d75039dd2ce903aea338664a9a6))

* Remove input upsampling ([`b50c7b6`](https://github.com/2428/Aquila-Consortium/map2map/commit/b50c7b6350b30a944fe5bfebed72ed2ca3fb6860))

* Add better looking tensorboard images ([`a88f27a`](https://github.com/2428/Aquila-Consortium/map2map/commit/a88f27a3a1488bfc04c4993d52e53fa5d42d23de))

* Add auto loading of checkpoint ([`996c0d3`](https://github.com/2428/Aquila-Consortium/map2map/commit/996c0d3aedab20ed27feaa4d5934bcb537b61aaa))

* Add explicit barrier after init dist groups ([`c9f468c`](https://github.com/2428/Aquila-Consortium/map2map/commit/c9f468c5687f30f3ca5585c77b65f3b12b2828c5))

* Add default values to command line help ([`28d7cc9`](https://github.com/2428/Aquila-Consortium/map2map/commit/28d7cc9e9b3c975453eafa4d0b6170910993788b))

* Add TOC ([`356e28c`](https://github.com/2428/Aquila-Consortium/map2map/commit/356e28c31fd2318657400603c7e6d651a86e1f34))

* Add exit when GPU not found ([`5adf6cb`](https://github.com/2428/Aquila-Consortium/map2map/commit/5adf6cbac641ebe4a7c928216dcec95f6406883e))

* Add descriptions on files and tensorboard ([`facfc13`](https://github.com/2428/Aquila-Consortium/map2map/commit/facfc13132882208f07a03f251d118d9434220b8))

* Add checkpoint symlink to state file ([`01a60cc`](https://github.com/2428/Aquila-Consortium/map2map/commit/01a60cc0c7aa9b91034d86045c53e9d6fc35350c))

* Add noise annealing duration ([`d01d0ce`](https://github.com/2428/Aquila-Consortium/map2map/commit/d01d0cee830b20ca45418d35a893e6aa63c32ef8))

* Change state saving to every epoch ([`93d973b`](https://github.com/2428/Aquila-Consortium/map2map/commit/93d973b5c8006943b9b4f37b390f229b23c1fc79))

* Rewrite instance noise annealing scheduler ([`ccb323e`](https://github.com/2428/Aquila-Consortium/map2map/commit/ccb323e6ee86c26c8965f31421b06c121b2a5c6a))

* Add new pytorch features with fallback to old ([`7a0f0bd`](https://github.com/2428/Aquila-Consortium/map2map/commit/7a0f0bd979e84da21ab9f045f4c4159e88acfa56))

* Make main.py runnable ([`b7b14a3`](https://github.com/2428/Aquila-Consortium/map2map/commit/b7b14a37eb53df8cc6e9dfdc60e3f1f30a9b63a6))

* Fix spectral norm interference with gradient visualization

spectral norm introduces weight_orig, so that not all weight parameters
ends with &#34;.weight&#34; ([`5fbf447`](https://github.com/2428/Aquila-Consortium/map2map/commit/5fbf447e2d8e336683c96b6a074501c72e8c59e8))

* Fix bug from 1963530 to show last instead of 2nd layer gradients ([`33fd13e`](https://github.com/2428/Aquila-Consortium/map2map/commit/33fd13e4acaff1730f41997a14ec6a74fbf95513))

* Add instructions ([`d768aad`](https://github.com/2428/Aquila-Consortium/map2map/commit/d768aadb3637e8154f6481242adc21704e799fff))

* Add instance noise ([`ef993d8`](https://github.com/2428/Aquila-Consortium/map2map/commit/ef993d83e9c922b388c5ccd6c86e72eb1b205091))

* Add gradient norms to tensorboard ([`1963530`](https://github.com/2428/Aquila-Consortium/map2map/commit/1963530984c9872af2909c7db5f9b6934558c5c6))

* Add weight initialization ([`9567db7`](https://github.com/2428/Aquila-Consortium/map2map/commit/9567db7332b316d64024e5204948068dbfbff09c))

* Combine input and output figures ([`75b1c19`](https://github.com/2428/Aquila-Consortium/map2map/commit/75b1c19dcd524b0a9b0b32ab1a05e29247d75dc1))

* Fix bug when env SLURM_STEP_NUM_NODES is not defined ([`a467462`](https://github.com/2428/Aquila-Consortium/map2map/commit/a46746287abba8a579edc04f0f6f29001dd25e10))

* Remove label smoothing for generator ([`5cb4a1b`](https://github.com/2428/Aquila-Consortium/map2map/commit/5cb4a1bbaed24e738e55fc2ccbfa3caf9367a3ea))

* Add runtime address and port determination and share them via file

Together with slurm step node counts, make it possible to launch
multiple training in one job ([`b67079b`](https://github.com/2428/Aquila-Consortium/map2map/commit/b67079bf728c126ff9a6ab547b26fc5ffc607038))

* Add simple label smoothing by --adv-real-label ([`1818e11`](https://github.com/2428/Aquila-Consortium/map2map/commit/1818e11265a128811cd48592cdf4e3c16a96dd35))

* Add --adv-start as epoch to start adversarial training

This is similar to the deprecated --adv-delay, but specify
absolute epoch (--adv-delay counts from start_epoch in resumed training) ([`d2840f0`](https://github.com/2428/Aquila-Consortium/map2map/commit/d2840f01b0a5f596ba4405ffb5948f31263d6bf3))

* Move map loss computation forward in training ([`e8039dc`](https://github.com/2428/Aquila-Consortium/map2map/commit/e8039dcccca9036e0fa63d6a088e0aca521ab4ee))

* Fix warnings on incompatible keys ([`e383ec3`](https://github.com/2428/Aquila-Consortium/map2map/commit/e383ec3977851c08f463f6a852fb26544537c8b0))

* Change to nearest interpolation from linear in model super-resolution

To be consistent with the data super-resolution in data/fields.py ([`53ed5a9`](https://github.com/2428/Aquila-Consortium/map2map/commit/53ed5a91f427686aac340a9fb785d8dc0ec7fc55))

* Disable D grad when updating G; Revert D and G order

The reason for the latter is to follow most code but I haven&#39;t
found the reason ([`db3414e`](https://github.com/2428/Aquila-Consortium/map2map/commit/db3414e11c227d19485ae4dc3d74914b76e7b529))

* Add stride to ConvBlock ([`aeeeb96`](https://github.com/2428/Aquila-Consortium/map2map/commit/aeeeb966d87d7d8a81c40371426e0518da345b49))

* Fix bug: pprint -&gt; pformat ([`cc0efd2`](https://github.com/2428/Aquila-Consortium/map2map/commit/cc0efd28ec7e61c9e93e8d0ce1f054b662ca9369))

* Add spectral normalization ([`2e2adc7`](https://github.com/2428/Aquila-Consortium/map2map/commit/2e2adc761d005fb1336d208d5d4913e4e730f2ab))

* Fix stupid merging bug ([`b41e85e`](https://github.com/2428/Aquila-Consortium/map2map/commit/b41e85eda5b6c3fc4878bba01b6709f3cdea2a6b))

* Merge branch &#39;anneal_loss&#39;

Conflicts:
	map2map/models/patchgan.py
	map2map/train.py ([`16b82fc`](https://github.com/2428/Aquila-Consortium/map2map/commit/16b82fcc5639e2f8a75ef1bb4cd6593fc29a89cd))

* Add argument to disable ReduceLROnPlateau by default ([`2aed00d`](https://github.com/2428/Aquila-Consortium/map2map/commit/2aed00d97e5f3a78aa55591a784c7b64f23bb618))

* Change PatchGAN architecture ([`a2e3a9d`](https://github.com/2428/Aquila-Consortium/map2map/commit/a2e3a9dc6493961d3d13f67a50452d53d8383441))

* Extend training epochs in example scripts ([`1dd2b6d`](https://github.com/2428/Aquila-Consortium/map2map/commit/1dd2b6d7481f0fc2be56729146c3636d1ed26d5e))

* Add non-strict model state loading ([`09493ad`](https://github.com/2428/Aquila-Consortium/map2map/commit/09493ad4ec3dc3f980b7baed9d70738a3dea8ac5))

* Add PatchGAN42 similar to the PatchGAN in pix2pix ([`f831afb`](https://github.com/2428/Aquila-Consortium/map2map/commit/f831afbccf4c10a358ee71ffec05189570b1ff3c))

* Add pretty-print argument to job stdout ([`45c1d57`](https://github.com/2428/Aquila-Consortium/map2map/commit/45c1d57e72c9a683e6977ea304899fa0f46ff3fc))

* Remove saving / loading optimizer &amp; scheduler states

Conflicts:
	map2map/train.py ([`3fb9708`](https://github.com/2428/Aquila-Consortium/map2map/commit/3fb97085756d776e3d02a4f9af2aad878742b65a))

* Remove saving / loading optimizer &amp; scheduler states ([`23b903f`](https://github.com/2428/Aquila-Consortium/map2map/commit/23b903f81bc3ef910dcaac61e63966ac5008e9b6))

* Remove lazy argument feeding from field dataset ([`1cd34c2`](https://github.com/2428/Aquila-Consortium/map2map/commit/1cd34c2eed572037e047de0ebb2be23e8a874e72))

* Fix bug ([`890a459`](https://github.com/2428/Aquila-Consortium/map2map/commit/890a459363d986ecb2cd603294c982765e9df439))

* Change delayed adversary to a smooth annealing scheme ([`cd63324`](https://github.com/2428/Aquila-Consortium/map2map/commit/cd63324724c88363d20e6c6397206266fd24ee92))

* Add diff between out and tgt to figure ([`291dfb2`](https://github.com/2428/Aquila-Consortium/map2map/commit/291dfb24b32d9303446ccd5d9a6f4cd24388d06e))

* Change linear interpolation to nearest in super-resolution ([`e20f319`](https://github.com/2428/Aquila-Consortium/map2map/commit/e20f3194a574a6f7946fbb70dc8338e8d2d10f07))

* Add pyramid network ([`679f9f2`](https://github.com/2428/Aquila-Consortium/map2map/commit/679f9f25454fd9a8a3d1b7570a5fefb6705f5211))

* Change noise channel removal from input ([`a5c48e7`](https://github.com/2428/Aquila-Consortium/map2map/commit/a5c48e71b046770f356ff8167fe316c4ca9ac942))

* Fix upsampling crop bug ([`ef0235f`](https://github.com/2428/Aquila-Consortium/map2map/commit/ef0235f97b4c467a8151c286836b2086256e8097))

* Add per field colormap and Fix scope bug ([`b609797`](https://github.com/2428/Aquila-Consortium/map2map/commit/b609797e274f6e44901ae6b8425ed6f723141e59))

* Wrap Dice loss with nn.Module ([`a22fb64`](https://github.com/2428/Aquila-Consortium/map2map/commit/a22fb64d1202969df2c5ff7b3006b35fb17d1d58))

* Add figures with tensorboard ([`db69e9f`](https://github.com/2428/Aquila-Consortium/map2map/commit/db69e9f953c8f1297214cd15bb07aa0b37c7b877))

* Add delay to scheduler by adv_delay ([`7f6578c`](https://github.com/2428/Aquila-Consortium/map2map/commit/7f6578c63eb5d5e62f46c19e6e06d4d7262001b6))

* Add wrappers of adversary model and adversarial loss

commit c0dafec94bb7d131938650027f84e5308bf16ffd
Author: Yin Li &lt;eelregit@gmail.com&gt;
Date:   Mon Feb 3 11:18:08 2020 -0600

    Fix bug

commit b470b873649515f4b8a1cac7b4b33181eac51199
Author: Yin Li &lt;eelregit@gmail.com&gt;
Date:   Mon Feb 3 09:39:08 2020 -0600

    Fix bug

commit 9f8f64b3510c72bfcf2a1236ba5285edf280701c
Author: Yin Li &lt;eelregit@gmail.com&gt;
Date:   Mon Feb 3 10:20:37 2020 -0500

    Add wrappers of adversary model and adversarial loss ([`0a2fc9a`](https://github.com/2428/Aquila-Consortium/map2map/commit/0a2fc9a9e954a19e909758475afb94367dafdde8))

* Add displacement to density script ([`a237245`](https://github.com/2428/Aquila-Consortium/map2map/commit/a237245514b955aac5055e943a9582342ad2d35a))

* Add exp and log functions from torch ([`ea61bb9`](https://github.com/2428/Aquila-Consortium/map2map/commit/ea61bb9b658f1fe9745bb4d11b0ae322135c6443))

* Add Dice loss ([`698b2a8`](https://github.com/2428/Aquila-Consortium/map2map/commit/698b2a8df71d07ec9847db0d79f7d2eceb0a75ac))

* Add noise channels to the input ([`0721301`](https://github.com/2428/Aquila-Consortium/map2map/commit/07213011130fc4ee39399440bd30d7f6e821165b))

* Merge branch &#39;master&#39; of github.com:eelregit/map2map

Conflicts:
	scripts/srsgan.slurm ([`31ea70f`](https://github.com/2428/Aquila-Consortium/map2map/commit/31ea70fca923fe63e39f4af0a74d68c641dd44e9))

* Fix slurm script for training on 2 nodes on Frontera ([`ec07474`](https://github.com/2428/Aquila-Consortium/map2map/commit/ec074748d040d82e9412c58ca9045b71c10b4020))

* Fix super-resolution script for Frontera ([`0d18276`](https://github.com/2428/Aquila-Consortium/map2map/commit/0d1827669a0c7c78d2e6f0fae76a6381c8b9aff6))

* Merge branch &#39;master&#39; of github.com:eelregit/map2map ([`1b3f32b`](https://github.com/2428/Aquila-Consortium/map2map/commit/1b3f32b791ce7a2f6feef427773b5ea9d48d6cfe))

* Merge branch &#39;master&#39; of github.com:eelregit/map2map ([`71bf37d`](https://github.com/2428/Aquila-Consortium/map2map/commit/71bf37d0aa659e4c2d0336ac5a03a521950fa37c))

* Fix touch-up... ([`de71df5`](https://github.com/2428/Aquila-Consortium/map2map/commit/de71df51f5d2fbedb0259037ac86c8c16e2b9554))

* fix crop function with upsample ([`d5b76b3`](https://github.com/2428/Aquila-Consortium/map2map/commit/d5b76b3725ffb4eb1b1dc5f4cb6b8e45311634a5))

* Merge branch &#39;master&#39; of github.com:eelregit/map2map ([`1008312`](https://github.com/2428/Aquila-Consortium/map2map/commit/1008312a20810146d0e563ddd5012be8e3fb82aa))

* Merge ([`55ee131`](https://github.com/2428/Aquila-Consortium/map2map/commit/55ee131910255e8bb137f834f9530f4be24eec9e))

* Change tensorboard to optional dependency ([`581ad5d`](https://github.com/2428/Aquila-Consortium/map2map/commit/581ad5d60bcc25b3a05286d2aa5a7c94adbd3848))

* Change tensorboard to optional dependency ([`6252629`](https://github.com/2428/Aquila-Consortium/map2map/commit/6252629631f99be890c4e9dee70d11aa23f64f18))

* Fix bug that target needs to be cropped with upsampled size ([`6c030f1`](https://github.com/2428/Aquila-Consortium/map2map/commit/6c030f1eb1a19c9a4e36fe7be335d656f7710559))

* Fix bug that F.interpolate does not apply to np arrays ([`6938eea`](https://github.com/2428/Aquila-Consortium/map2map/commit/6938eea08983aef49c4b1ac07b21a5b977442af5))

* Add super-resolution ([`84a369d`](https://github.com/2428/Aquila-Consortium/map2map/commit/84a369d4ed9012c2efd82c8c5e7fa3848dea09d2))

* Add PatchGAN to __init__ ([`ba42bc6`](https://github.com/2428/Aquila-Consortium/map2map/commit/ba42bc6a5589096b68a945a5c70ed9f7a0e858a5))

* Swap generator &amp; discriminator order in training

The reasoning is that updating generator first will free up the memory
taken by the graph of the model ([`862c9e7`](https://github.com/2428/Aquila-Consortium/map2map/commit/862c9e75a0fca22a76489c90416c394e026e9a7c))

* Add delay epoch before updating generator with adversarial loss ([`f99fd6b`](https://github.com/2428/Aquila-Consortium/map2map/commit/f99fd6b177fab7b17b62b06c90ba64742f90d55e))

* Add a simple PatchGAN ([`cdb00eb`](https://github.com/2428/Aquila-Consortium/map2map/commit/cdb00ebd8dfc3f2f05193422927173747adcf409))

* Add separate input and target normalization ([`c68b992`](https://github.com/2428/Aquila-Consortium/map2map/commit/c68b9928ee48ab21bf9e0026e9ea53fcff518f20))

* Fix augmentation bug ([`46a3a3a`](https://github.com/2428/Aquila-Consortium/map2map/commit/46a3a3a97deea0ff9a24932a70e3e92b98a17309))

* Make both fat and lean V-Net available ([`1f89e89`](https://github.com/2428/Aquila-Consortium/map2map/commit/1f89e894cc13b28f15c7713c577a651f7ae75279))

* Update slurm script to include adversary model ([`6e06682`](https://github.com/2428/Aquila-Consortium/map2map/commit/6e06682751acb0fee4f5316d50e43d5c18697a40))

* Change U-Net and V-Net inner naming convention; Slim down V-Net ([`94ce018`](https://github.com/2428/Aquila-Consortium/map2map/commit/94ce018cb84fe07c17a0603579f3495d1d26cc3f))

* Change activation default to leaky ReLU in conv block ([`01ff0ac`](https://github.com/2428/Aquila-Consortium/map2map/commit/01ff0aca37d306557a31c21fe81ca82002249beb))

* Remove model loading hack in testing ([`6e48905`](https://github.com/2428/Aquila-Consortium/map2map/commit/6e48905cc0795900c342191cf41a4450b9fc8a29))

* Change adversary optim scheduler to sync with model optim scheduler ([`2b7e559`](https://github.com/2428/Aquila-Consortium/map2map/commit/2b7e559910b91f61eb1f573d2a6420e042d40a89))

* Fix adversary model optim scheduler ([`e7d2435`](https://github.com/2428/Aquila-Consortium/map2map/commit/e7d2435a9640dc9c669674f0809ffcec9f5b74d3))

* Fix (possibly) multiple DistributedDataParallel reduce interference ([`1b1e0e8`](https://github.com/2428/Aquila-Consortium/map2map/commit/1b1e0e82fa01ee71265e250bb850d5e96f88ddd7))

* Add optional adversary model and make validation optional ([`15384dc`](https://github.com/2428/Aquila-Consortium/map2map/commit/15384dc9bdd7fcb7717de795c38b09da70967993))

* Fix seeding bug introduced in the completely wrong commit f64b1e4 ([`9cf97b3`](https://github.com/2428/Aquila-Consortium/map2map/commit/9cf97b3ac129ba92c349491b92b15f5c89991c1d))

* Change __dict__ to getattr ([`848dc87`](https://github.com/2428/Aquila-Consortium/map2map/commit/848dc871694271cd9b73e7b011f2b7bb8f4b4275))

* Cache data during the first epoch ([`77710bc`](https://github.com/2428/Aquila-Consortium/map2map/commit/77710bc8a30cee37da65bdf91ebc469173d946e8))

* Add data division, good with data caching ([`01b0c8b`](https://github.com/2428/Aquila-Consortium/map2map/commit/01b0c8b5142e7ef81e8bd98944858c8fec30bc63))

* Fix testing glob patterns ([`de24f8d`](https://github.com/2428/Aquila-Consortium/map2map/commit/de24f8d5855f898b1b72bdf91b29fc2fac42f7ba))

* Print args in testing ([`796c791`](https://github.com/2428/Aquila-Consortium/map2map/commit/796c7918d8050e8855222a52073f640ad7748d34))

* Add data caching, and new pad and crop features ([`843fe09`](https://github.com/2428/Aquila-Consortium/map2map/commit/843fe09a926e05778d5509a3eec1f2f2dafb5d7f))

* Fix bug from 0533150 ([`d03bcb5`](https://github.com/2428/Aquila-Consortium/map2map/commit/d03bcb59a1d678b045b74b2d19bfc2533dd58bc0))

* Simplify swish for readability ([`6d021ec`](https://github.com/2428/Aquila-Consortium/map2map/commit/6d021ec9496374585f1e0fcb02747c3cd9abec85))

* Save past best models by not overwriting them ([`0533150`](https://github.com/2428/Aquila-Consortium/map2map/commit/05331501943f5328239867d49bb1995554e7af0e))

* Add swish activation, kernel_size in ConvBlock, and optional trailing activation in ResBlock ([`946805c`](https://github.com/2428/Aquila-Consortium/map2map/commit/946805c6be6be8e58955199d3022db4d92b4cfb2))

* Fix issue that pytorch 1.1 does not flush tensorboard ([`341bdbf`](https://github.com/2428/Aquila-Consortium/map2map/commit/341bdbff848f6518674d9909340bf67f716405fa))

* Add weight decay ([`bd37982`](https://github.com/2428/Aquila-Consortium/map2map/commit/bd3798222aff31f93ba2a61f79fcc6c00a397739))

* Fix bug in cropping width indices ([`96b683b`](https://github.com/2428/Aquila-Consortium/map2map/commit/96b683bfefc38318d56a67df2c1edc8cc512449c))

* Fix input shape and norm, and target norm in testing ([`0c4a551`](https://github.com/2428/Aquila-Consortium/map2map/commit/0c4a551354931f6b51c733e71d4b48d84725e571))

* Move UNet with ResBlock to VNet and Revert UNet to the previous simple version ([`7b6ff73`](https://github.com/2428/Aquila-Consortium/map2map/commit/7b6ff73be14e6c1ab48e8e4e10ad7ae93f4b9dd0))

* Add variable skip connection in ResBlock ([`9e039c0`](https://github.com/2428/Aquila-Consortium/map2map/commit/9e039c0407bb165514bc8ead3f16e8a2fe614890))

* Remove pytorch version constraint and Add python 3 constraint in setup.py ([`139caab`](https://github.com/2428/Aquila-Consortium/map2map/commit/139caabe31e83d75996b3969180e5a58276cf7fd))

* Remove unnecessary arguments --in-channels and --out-channels ([`0764a10`](https://github.com/2428/Aquila-Consortium/map2map/commit/0764a1006ee448b33e8dc83839eb745ff11b3727))

* Add synchronized random seed to training ([`f64b1e4`](https://github.com/2428/Aquila-Consortium/map2map/commit/f64b1e42e9392225fda3a27613a43bb9033cb419))

* Fix unstable training by limiting pytorch version to 1.1 ([`11c9caa`](https://github.com/2428/Aquila-Consortium/map2map/commit/11c9caa1e241b698654a06c60352669367ea9e27))

* Fix DistributedDataParallel model save and load during training, leave testing for later ([`437126e`](https://github.com/2428/Aquila-Consortium/map2map/commit/437126e296b960801eb70e73b13a5bfce2386aa1))

* Revert scheduler to ReduceLROnPlateau ([`f2e9af6`](https://github.com/2428/Aquila-Consortium/map2map/commit/f2e9af6d5f222d03c2709135126d6e30d2e5e266))

* Merge branch &#39;master&#39; of github.com:eelregit/map2map

Conflicts:
	map2map/train.py ([`34b8c62`](https://github.com/2428/Aquila-Consortium/map2map/commit/34b8c62c7614663487fa126ce638151e9e2cb805))

* Change ReduceLROnPlateau to CyclicLR ([`b253bb6`](https://github.com/2428/Aquila-Consortium/map2map/commit/b253bb687bea9102916671913b9b4af32d06bb41))

* Merge branch &#39;master&#39; of github.com:eelregit/map2map ([`054ccb1`](https://github.com/2428/Aquila-Consortium/map2map/commit/054ccb194efc4b8d364936bcb3f3def4e5b2c616))

* Change ReduceLROnPlateau to CyclicLR ([`044e4c9`](https://github.com/2428/Aquila-Consortium/map2map/commit/044e4c93762ffde8a7ebcddf360365d153b2c3c9))

* Merge branch &#39;master&#39; of github.com:eelregit/map2map ([`1f6b34d`](https://github.com/2428/Aquila-Consortium/map2map/commit/1f6b34dbf6cd22972b7e2a79d8ec5f4a8765020f))

* Change ReduceLROnPlateau to CyclicLR ([`36cf2ac`](https://github.com/2428/Aquila-Consortium/map2map/commit/36cf2ac93b7d8e44f1e9a7aec489d61f0e3ad8d0))

* Merge branch &#39;master&#39; of github.com:eelregit/map2map

Conflicts:
	map2map/train.py ([`afeefca`](https://github.com/2428/Aquila-Consortium/map2map/commit/afeefcaa9e05817c13c02efa4367d8183e6ce944))

* Change ReduceLROnPlateau to CyclicLR ([`7540154`](https://github.com/2428/Aquila-Consortium/map2map/commit/7540154eba8d127bc68bd11ae02bb3ee0e55a5f3))

* Change ReduceLROnPlateau to CyclicLR ([`bf3fe86`](https://github.com/2428/Aquila-Consortium/map2map/commit/bf3fe86afe419b13958f9f50540b60b3e48bf271))

* Add testing ([`0211eed`](https://github.com/2428/Aquila-Consortium/map2map/commit/0211eed0ec1bd453254037ecb5f9c7ab52514003))

* Fix global_step in tensorboard summary to start from 1 ([`bcf9527`](https://github.com/2428/Aquila-Consortium/map2map/commit/bcf95275f3b43327335db4f48922adaa08455aef))

* Add enhanced model

Add ResBlock using ConvBlock;
Use ResBlock in UNet;
Use PReLU instead of LeakyReLU;
Add more channels in lower levels in UNet;
Add more blocks in each level in UNet; ([`9d4b5da`](https://github.com/2428/Aquila-Consortium/map2map/commit/9d4b5daae370cb73c36fdd3d6daa1ea95ffacc96))

* Add training ([`88bfd11`](https://github.com/2428/Aquila-Consortium/map2map/commit/88bfd11594f07a6c0e1d927879aea59fafe068c3))

* Initial commit ([`6015dd6`](https://github.com/2428/Aquila-Consortium/map2map/commit/6015dd6b31d11d23be1efd5dc52625672b3121ef))
